@extends('layouts.app')

@section('title','My memos')

@section('main')
	@parent

	<section>
		<ul>
			<li><a href="{{ route('view_home') }}">Home</a></li>
			<li><a href="{{ route('view_account') }}">My Account</a></li>
		</ul>
	</section>

	@foreach (session('user')->fresh()->memos as $memo)
		<article>
			<h2>{{$loop->index + 1}} - {{ $memo->title }}</a></h2>
			<section>
				@if ($memo->published_on != null)
					Publié le : {{ $memo->published_on }}.<br>
				@endif
				Mis à jour le : {{ $memo->last_update }}.
			</section>
			<section>
				{{ $memo->content }}
			</section>
			<section>
				State: {{ $memo->public ? 'Public' : 'Not public' }}.
			</section>
			<section>
				<a href="{{ route("view_formeditmemo", ['memo_id' => $memo->id ]) }}">Edit</a> -
				<a href="{{ route("memo_changestatus", ['memo_id' => $memo->id ]) }}">Change status</a>
			</section>
		</article>
	@endforeach

@endsection
