<?php
/******************************************************************************
 * Initialisation.
 */

session_start();
unset($_SESSION['message']);

/******************************************************************************
 * Traitement des données de la requête
 */

// 1. On vérifie que la méthode HTTP utilisée est bien POST


// 2. On vérifie que les données attendues existent


// 3. On sécurise les données reçues


/******************************************************************************
 * Initialisation de l'accès à la BDD
 */

try {
	require_once('bdd.php');
	$pdo = new PDO($SQL_DSN);
}
catch( PDOException $e ) {
	$_SESSION['message'] = 'PDO error : '.$e->getMessage();
	header('Location: signup.php');
	exit();
}

/******************************************************************************
 * Ajout de l'utilisateur
 */

// 1. On prépare la requête
$request = $pdo->prepare( "..." );

// 2. On assigne les paramètres nommés

// 3. On exécute la requête
try {
	$ok &= $request->execute();
} catch (Exception $e) {
	$_SESSION['message'] = "Login still exists. Try another one.";
	header('Location: signup.php');
	exit();
}

// 4. On vérifie que la requête s'est executée sans erreur
if ( !$ok )
{
	$_SESSION['message'] = "Account creation error, try again.";
	header('Location: signup.php');
	exit();
}

// 5. On indique que le compte a bien été créé
$_SESSION['message'] = "Account created! Now, signin.";

// 6. On sollicite une redirection vers la page d'accueil
header('Location: signin.php');
exit();
