TP9 - Prise en main de Laravel
==============================

Objectifs
---------

Comprendre l'utilisation du framework Laravel.

Nous souhaitons mettre en place une application fonctionnelle **qui respecte le découpage MVC**.


Exercice 1 : Installation
-------------------------

Suivez les indications données dans [LARAVEL-installation.md](LARAVEL-Installation.md).


Exercice 2 : Création dune vue et de la route associée
---------------------------------

1. Dans `resources/views/`, ajouter une vue :
	- `fichierHTML.php`

1. Dans `routes/web.php` :
	- Écrivez la routes GET `page1`  renvoyant la vue `fichierHTML.php`.


Exercice 3 : BDD
----------------------------------

1. Créer un fichier `.env` s'il n'existe pas en copiant le fichier `.env.example`.

1. Consultez le fichier `.env` pour y trouver où est indiquer le SGBD et la base de données utilisée.


Exercice 4 : Contrôleur
----------------------------------------------

À l'aide d'`artisan`, créez une contrôleur `UserController` (`php artisan make:controller UserController`).

1. Créez une méthode `afficherPage` dans le contrôleur.

1. Ecrire le code de la méthode `afficherPage` de sorte à ce qu'elle renvoie juste la page définie dans l'exercice 3 (`return view ("fichierHTML");`)

1. Modifiez le routeur `page1` de sorte à ce qu'elle utilise le contrôleur.

Exercice 5 : Site complet d'authentification
----------------------------------------------

1. Utiliser et comprenez l'application Laravel d'authentification contenu dans le répertoire authentification :
	1. Inspectez le fichier de routage `routes/web.php` pour voir les différentes routes de l'application.  
	
	2. Inspecter le répertoire `ressources/views` pour voir les différentes vues de l'applications. Les vues sont au format `blade` et ils utilisent un `layout` de base définie dans `resources/views/layouts/mainLayout.blade.php`.  
	
	3. Inspectez le répertoire `app/Models` pour voir le différents modèle utilisé par l'application. Le model est présent dans une version détaillée (`MyUser_old.php`) et dans une version gérée par l'ORM `Eloquent`.  
	
	4. Inspectez le répertoire `app/Http/Controllers` pour voir les contrôleurs utilisées par l'application.